// naumann@stce.rwth-aachen.de

#include "dco.hpp"

#include "f.hpp"

template<typename T, typename PT>
void first_derivative(T &x_v, const PT &p, const PT &w, T &dx) {
  using DCO_T=typename dco::gt1s<T>::type;
  DCO_T x; // activate
  dco::value(x)=x_v; dco::derivative(x)=1; // seed
  f(x,p,w); // compute
  dx=dco::derivative(x); x_v=dco::value(x); // harvest
}

#include "g_main.hpp"
