// naumann@stce.rwth-aachen.de

#pragma once

template<typename T>
T f1(const T &x) { return sin(x); }

template<typename T>
T f2(const T &x) { return cos(x); }

template<typename T, typename PT>
void f(T &x, const PT &p, const PT &w) {
  T a=f1(x);
  T b=f2(x);
  x=1/(1+exp(-(x-p)/w));
  x=a*(1-x)+b*x;
}
